/*
 * ʰץץե ڤؤġ
 * (Ȥꤢ single-task only ˤƤ)
 *
 * (C)Copyright 2009, Yashiro Takeshi <yashiromann@nifty.com>
 */

#include <basic.h>
#include <stdio.h>
#include <string.h>
#include <tcode.h>
#include <tstring.h>
#include <btron/tkcall.h>
#include "vf.h"

static TC str_on[] = {TK_o, TK_n, TNULL};
static TC str_off[] = {TK_o, TK_f, TK_f, TNULL};

extern W vf_open();
extern W vf_close();
extern W vf_start(W* tid, int n);
extern W vf_stop();
extern W vf_save(const char* fname);
extern W vf_status();


static const char* status()
{
    W er = vf_status();
    if (er < 0) {
        return (const char*)bstrerror(er);
    }
    return (er ? "started" : "stopped");
}


int main(W argc, TC* argv[])
{
    W er;
    if (argc <= 1) {
        goto err_ret;
    }
    else if (tc_strcmp(argv[1], str_on) == 0 && argc == 3) {
        W tid = tc_atoi(argv[2]);
        er = vf_open();
        if (er < 0) {
            printf("Error(open): %s\n", bstrerror(er));
            return 1;
        }
        er = vf_start(&tid, 1);
        if (er < 0) {
            printf("Error(start): %s\n", bstrerror(er));
            vf_close();
            return 1;
        }
        vf_close();
        printf("Started probing tid = %d\n", tid);
    }
    else if (tc_strcmp(argv[1], str_off) == 0 && argc == 2) {
        er = vf_open();
        if (er < 0) {
            printf("Error(open): %s\n", bstrerror(er));
            return 1;
        }
        vf_stop();
        er = vf_save("/SYS/vf.out");
        if (er < 0) {
            printf("Error(save): %s\n", bstrerror(er));
            vf_close();
            return 1;
        }
        vf_close();
        printf("Stopped probing\n");
    }
    else {
        goto err_ret;
    }
    return 0;

err_ret:
    printf("Usage: vfswitch [on <tid>|off]\n");
    vf_open();
    printf("Current status: %s\n", status());
    vf_close();
    return 1;
}

