/*
 * ʰץץեѥ饤֥
 *
 * (C)Copyright 2009, Yashiro Takeshi <yashiromann@nifty.com>
 */

#include <basic.h>
#include <stdio.h>
#include <btron/tkcall.h>
#include <btron/errcode.h>
#include "vf.h"

static W dd = -1;


W vf_open()
{
    W er;

    if (dd >= 0) {
        return 0;
    }

    er = tk_opn_dev("vf", TD_UPDATE|TD_EXCL);
    if (er < 0) {
        return er;
    }

    dd = er;
    return 0;
}


W vf_close()
{
    W wdata, asize;

    if (dd < 0) {
        return 0;
    }

    tk_cls_dev(dd, 0);
    dd = -1;
    return 0;
}


W vf_start(W* tid, int n)
{
    W er, asize, wdata;

    if (dd < 0) {
        return E_NOEXS;
    }

    wdata = 0;
    er = tk_swri_dev(dd, DN_VFENABLE, &wdata, sizeof(W), &asize);
    if (er < 0) {
        goto err_ret;
    }

    wdata = 1;
    er = tk_swri_dev(dd, DN_VFCLEAR, &wdata, sizeof(W), &asize);
    if (er < 0) {
        goto err_ret;
    }

    er = tk_swri_dev(dd, DN_VFTASK, tid, sizeof(W) * n, &asize);
    if (er < 0) {
        goto err_ret;
    }

    wdata = 1;
    er = tk_swri_dev(dd, DN_VFENABLE, &wdata, sizeof(W), &asize);
    if (er < 0) {
        goto err_ret;
    }

    return 0;

err_ret:
    return er;
}


W vf_status()
{
    W er, asize, wdata;

    if (dd < 0) {
        return ER_NOEXS;
    }

    wdata = 0;
    er = tk_srea_dev(dd, DN_VFENABLE, &wdata, sizeof(W), &asize);
    if (er < 0) {
        goto err_ret;
    }
    return (wdata ? 1 : 0);

err_ret:
    return er;
}


W vf_stop()
{
    W er, asize, wdata;

    if (dd < 0) {
        return 0;
    }

    wdata = 0;
    er = tk_swri_dev(dd, DN_VFENABLE, &wdata, sizeof(W), &asize);
    if (er < 0) {
        goto err_ret;
    }
    return 0;

err_ret:
    return er;
}


W vf_save(const char* fname)
{
    W er, asize, wdata;
    VFEntry buf[128];
    FILE* fp;

    wdata = 0;
    er = tk_swri_dev(dd, DN_VFPC, &wdata, sizeof(W), &asize);
    if (er < 0) {
        goto err_ret0;
    }

    fp = fopen(fname, "w");
    if (fp == NULL) {
        goto err_ret0;
    }

    for (;;) {
        er = tk_srea_dev(dd, 0, buf, sizeof(buf), &asize);
        if (er < 0) {
            goto err_ret1;
        }
        if (asize == 0) {
            break;
        }
        asize /= sizeof(VFEntry);
        fwrite(buf, sizeof(VFEntry), asize, fp);
    }

    /* ٤Ƥޤä˸¤ꡢ򥯥ꥢ */
    wdata = 0;
    tk_swri_dev(dd, DN_VFENABLE, &wdata, sizeof(W), &asize);
    tk_swri_dev(dd, DN_VFCLEAR, &wdata, sizeof(W), &asize);

    er = 0;

    /* FALLTHROUGH */
err_ret1:
    fclose(fp);

err_ret0:
    return er;
}
